  <%
 /*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s): Kamran Ahsan
 */
 %>
 <%@ page  errorPage="errorPage.jsp" contentType="text/html" import="java.net.URI,java.net.URLEncoder,java.net.URLDecoder, java.util.Iterator,webprotege.*,java.util.ArrayList,org.apache.commons.fileupload.*,java.util.List,java.io.*,edu.stanford.smi.protege.model.*,java.util.ArrayList,java.util.Collection,edu.stanford.smi.protege.util.PropertyList,webprotege.util.ProjectWrapper,java.util.HashMap,java.util.zip.*,org.apache.log4j.*,webprotege.util.*,java.util.Date,java.util.Timer,java.text.SimpleDateFormat"%>
 <%! protected static Category cat;%>
 <%
  cat = Category.getInstance("Index.JSP");
  User user=(User)session.getAttribute("user");
  if(user==null){%>
    <jsp:forward page="login.jsp" />
    <%}

  cat.info("Start of index.jsp file");
  Constants.initialize(getServletContext());
  String path = getServletContext().getRealPath(Constants.kbPath);
  cat.debug("path = " + path);
  HashMap hashMapPrivateProjects=(HashMap)request.getSession().getAttribute("privateProjects");
  File kbDirectory=new File(path);
  cat.debug("kbDirectory.exists() = " + kbDirectory.exists());
  if(kbDirectory.exists()){
    KBManager.setCurrentKbPath(path);

    /** If the SessionClener has not been launched so far, launch it. **/
    long timeSinceCleanUp=System.currentTimeMillis()-KBManager.timeSessionCleanerLaunched;
    cat.debug("timeSinceCleanUp = " + timeSinceCleanUp);
    if(timeSinceCleanUp > Constants.privateFolderTimeOut){
    /**  It will run in the background and execute a cleanup every 24 hours, deleting
    /***  All files with last modified date is older than 24 hours **/
    SessionCleaner sessionCleaner=new SessionCleaner();
    sessionCleaner.setKbDir(kbDirectory);
    sessionCleaner.clean();
    KBManager.timeSessionCleanerLaunched=System.currentTimeMillis();
    }
    /** Code to clean session ends **/

    /** Save Projects which may have changed **/
    long timeSinceProjectSave=System.currentTimeMillis()-KBManager.lastTimeProjectSaved;
    cat.debug("timeSinceProjectSave = " + timeSinceProjectSave);
    if(timeSinceProjectSave > Constants.projectSaveInterval){
    KBManager.saveProjects(); // this automatically updates the last time projects were saved
    }
    /** Code to save projects ends **/

  }
  File parentDir=null;
    try{
    parentDir=new File(path);
    parentDir.mkdirs();
    }catch (Exception ex){
      ex.printStackTrace();
      cat.error("KB Dire Error",ex);
      }
// check if we need to move a private ontology into public domain
  if(request.getParameter("op")!=null && request.getParameter("op").equalsIgnoreCase("makePublic")) {
	String ontologyName=URLDecoder.decode(request.getParameter("kb"),"UTF-8");
        cat.info("Move " + ontologyName + " from private to public");
// Move the zip file and then extract all the files in the public directory
Project project=null;
KnowledgeBase knowledgeBase=null;
project=(Project)hashMapPrivateProjects.get(ontologyName);
cat.debug("(Project)hashMapPrivateProjects.get(ontologyName) = " + project);
if(project==null) { // this should NEVER happen
knowledgeBase=KBManager.openKB(ontologyName);
project=knowledgeBase.getProject();
}else{
  knowledgeBase=project.getKnowledgeBase();
}


String zipFileName=project.getName() + ".zip";
File zipFile=new File(path + File.separator+ user.getLogin()+File.separator+zipFileName);
if(zipFile.exists()) { // move to the public dir
      cat.info("Moving file to public");
      cat.info("Extracting Ontology now");
      KBManager.extractOntology(zipFile.getAbsolutePath(),parentDir.getAbsolutePath(),path + File.separator+ user.getLogin());
    // Move file to new directory
    File newZipFile=new File(parentDir, zipFile.getName());
    zipFile.renameTo(newZipFile);
    zipFile.delete();

      // remove private ontology from the session
      Project tempProject = (Project) hashMapPrivateProjects.remove(ontologyName);
      cat.debug("ontologyName = " + ontologyName+ " tempProject = "+tempProject);
//      if(tempProject!=null){
//      cat.debug("Putting " + tempProject +  " in cache .. with key = " + tempProject.getName());
//      KBManager.putKBInCache(tempProject.getKnowledgeBase(),tempProject.getName()+".pprj");
//      }

      KBManager.saveMovedOwlProject(project,path);
      request.getSession().setAttribute("privateProjects",hashMapPrivateProjects);

}
    }
  %>
  <html>
  <head>
    <script language="javascript">
    function makePublic(kb,projectName){
      if(!confirm("Are you sure you want to make the Project '" + projectName + "'  public?"))
      return;
      document.forms["makePublicForm"].kb.value=kb;
      document.forms["makePublicForm"].op.value="makePublic";
      document.forms["makePublicForm"].action="index.jsp";
      document.forms["makePublicForm"].submit();
      }
    </script>
  <title>
  Prot&eacute;g&eacute; Web Browser
  </title>
<%@ include file="header.jsp"%>
<link rel="stylesheet" type="text/css" href="style/kb.css" />
<table border="0" cellpadding="4" cellspacing="0" width="60%">
<tr class="highlight" align=left valign=top>
<td colspan=3>
&nbsp;&nbsp;&nbsp;&nbsp;
</td>
</tr>
<tr align=left valign=top>
<td width=40%>
  <font size="+1">Public Projects: </font>
</td>
<td width=10%>
&nbsp;&nbsp;
</td>
 <%
 Iterator it = KBManager.getAllKBNames().iterator();
  while (it.hasNext()) {
    ArrayList nkb = (ArrayList)(it.next());
    if(((String)nkb.get(0)).equalsIgnoreCase("metaproject.pprj"))
    continue;
    cat.debug("Displaying a Public Project " + (String)nkb.get(1));
    cat.debug("Constants.displayKbs " + Constants.displayKbs);
    String kb = URLEncoder.encode((String)nkb.get(1),"UTF-8");
    String status="";
    String statusColor="";

    try {
      String prettyName=((String)nkb.get(0));
      if(prettyName.endsWith(".pprj")){
        prettyName=prettyName.substring(0,prettyName.length()-5);
        }else if (prettyName.endsWith(".owl")){
        prettyName=prettyName.substring(0,prettyName.length()-4);
          }
 // Load the project if not loaded already
Collection errors=new ArrayList();
Iterator iterator=null;
Project project = null;
KnowledgeBase knowledgeBase=null;
String projectFileName=URLDecoder.decode(kb,"UTF-8");
cat.debug("Loading Project " + projectFileName);
knowledgeBase=KBManager.openKB(projectFileName);
if(knowledgeBase!=null){
project=knowledgeBase.getProject();
     out.println("<tr valign=top>");
      out.println("<td><a href=\"browse.jsp?kb=" + kb +
                  "\" target=\"_KbBrowser\">" +  prettyName + "</a></td>");
/* Creating a zip archive for this ontology */
          String zipFileName=project.getName()+".zip";
          File zipFile=new File(parentDir,zipFileName);
          cat.debug("After creating zip file " + zipFile);
          cat.debug("After creating zip file " + zipFile.exists());
          if(zipFile.exists()){
            // dont do anything if the file already exists
            }else{
              // create a zip file for this project
cat.info(" Zip File Does not exist. Zipping now ... " );
byte[] buffer = new byte[18024];
ZipOutputStream zipOutputStream = new ZipOutputStream(new FileOutputStream(zipFile));
FileInputStream fileInputStream = new FileInputStream(new File(parentDir,projectFileName));
cat.info(" after creating file input stream " );
zipOutputStream.setLevel(Deflater.DEFAULT_COMPRESSION);
zipOutputStream.putNextEntry(new ZipEntry(kb));
cat.info(" zipFileName = " + zipFile.getAbsolutePath() + " projectFileName = " + projectFileName);
int len;
while ((len = fileInputStream.read(buffer)) > 0)
{
     zipOutputStream.write(buffer, 0, len);
}
    zipOutputStream.closeEntry();
     fileInputStream.close();
// done with putting in the project file for this ontology in the knowledgebase. now adding other files from sources

      PropertyList sources=project.getSources();
      iterator=sources.getNames().iterator();
      while(iterator.hasNext()){
        String aSource =(String)iterator.next();
        File componentFile=new File(parentDir,sources.getString (aSource));
        if(componentFile.exists()){
          // add to the zip file
fileInputStream = new FileInputStream(componentFile);
zipOutputStream.setLevel(Deflater.DEFAULT_COMPRESSION);
zipOutputStream.putNextEntry(new ZipEntry(componentFile.getName()));
while ((len = fileInputStream.read(buffer)) > 0)
{
     zipOutputStream.write(buffer, 0, len);
}
    zipOutputStream.closeEntry();
     fileInputStream.close();
          }
        }

       zipOutputStream.close();
// end of code to create the zip file
            }
//      status="<a href=\"" +  zipFile.getAbsolutePath() + "\"> Download </a>";
      status="<a href=\"" + request.getContextPath()+ File.separator + Constants.kbPath +  zipFile.getName() + "\"> Download </a>";
      statusColor="GREEN";

      out.println("<td><font color=\""+statusColor+"\">"+status+"</font></td>");
      out.println("</tr>");
} else{ // end of check for successful opening of kb
out.println("<tr valign=top> <td><font color=red> "+ projectFileName +":  Could Not Open KB !  </font></td></tr>");
}
    }catch(Exception ex){
      cat.error("Exception in Public Ontology Section",ex);
      ex.printStackTrace();
      }
    }
  %>
</table>
<%if(Constants.allowUploads){%>
<%@ include file="privateIndex.jsp"%>
<%}%>
<br>
  <hr>
<%@ include file="footer.jsp"%>
</html>
