<%--
/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s): Mark Woon, Mike Hewett, Kamran Ahsan
 */

--%>

<%--
/**
 * Displays tree for a KB.
 *
 * @param String kbName = request.getParameter("kb")
 * @param String nodeApp
 * @param String nodeAppTarget
 *
 * @throws Exception
 */
--%>
<%!
private String cleanId(String s){
String outStr=s;
searchReplace("\"","\\\"",outStr);
return outStr;
}

public static String searchReplace
(String search, String replace, String str)
{
int startIndex = str.indexOf ( search );
while( startIndex != -1)
{
str = str.substring ( 0, startIndex ) + replace + str.substring
( startIndex + search.length(), str.length() );
startIndex = str.indexOf ( search, startIndex
+ replace.length() );
}
return ( str );
}
%>
<%!
String kbName;
String treeNodeApp = "displayFrame.jsp";
String instancesJsp="displayInstances.jsp";
String treeNodeAppTarget = "details";
String instancesTarget = "instances";
StringBuffer treeParams;
KBTreeModel treeModel;
HashMap nodeStatusMap;
String currentNode;
boolean currentNodeIsLevelId;
String imagesDir="images"+java.io.File.separator+"tree" +java.io.File.separator;
// these two are just pointers to make out and request visible to printSubtree
JspWriter gOut;
HttpServletRequest gRequest;

void printSubtree(Frame frame, int level, int index, int parentChildCount, boolean grandparentIsAlone,
                  StringBuffer treeLayout, boolean showLeaf, boolean showLink) throws java.io.IOException {
cat.debug ("Frame is " + frame + "  : ");
    if (frame == null) {
        return;
    }
    cat.info(" class name " + ((Cls)frame).getBrowserText() + " class visible = " + ((Cls)frame).isVisible());
    if(!((Cls)frame).isVisible()){
cat.info("returning");
      return;
      }
    String id = frame.getName();
String encodedId=URLEncoder.encode(id,"UTF-8");
boolean hasMultipleParents=false;
String multipleParentsImageHtml="";
String abstractImageHtml="";
    String name = null;
    try {
      name = frame.getBrowserText();
      if (name == null) {
        name = id;
      }
      } catch (Exception ex1) {
        name = id;
      }
    boolean isLeaf = false;
    boolean isAbstract = false;
    boolean isMeta = false;
    if (treeModel.isLeaf(id)) {
        isLeaf = true;
        if (!showLeaf) {
            return;
        }
    } else {
        Cls cls = (Cls)frame;
        if (cls.isAbstract()) {
            isAbstract = true;
            abstractImageHtml="<img alt='This is an abstract class' src=\""+imagesDir+"Abstract.gif\"/>";
        }
        if (cls.isClsMetaCls()) {
            isMeta = true;
        }
if(cls.getDirectSuperclasses().size()>1){
hasMultipleParents=true;
multipleParentsImageHtml="<img alt='This class has Multiple SuperClasses' src=\""+imagesDir+"Multiple.gif\"/>";
}

    }
    int numChildren = treeModel.getChildCount(id);
    int numInstances=treeModel.getDirectInstanceCount(id);
    Boolean isOpen = (Boolean)nodeStatusMap.get(id + "-" + level);
    String levelId = id + "-" + level;
    if (numChildren > 0 && isOpen == null) {
        isOpen = new Boolean(false);
        nodeStatusMap.put(levelId, isOpen);
    }


    // print tree structure
    if (level > 0) {
        if (!grandparentIsAlone) {
            treeLayout.append("<img src=\"" +imagesDir+"tree-vert.gif\" border=\"0\" />");
        } else {
            treeLayout.append("<img src=\""+imagesDir+"tree-space.gif\" border=\"0\" />");
        }
    }
    gOut.print(treeLayout);
    String type;
    if (index == 0 && parentChildCount == 1 && level == 0) {
        type = "-root";
    } else if (index == parentChildCount - 1) {
            type = "-bottom";
    } else {
        type = "";
    }
    if (numChildren > 0) {
        String op;
        String prettyOp;
        if (isOpen.booleanValue()) {
            op = "close";
            prettyOp = "Close";
        } else {
            op = "open";
            prettyOp = "Open";
        }


        gOut.print("<a href=\"" + gRequest.getRequestURI() + "?kb=" + kbName + treeParams +
                   "&instanceSynch=false&id=" + id + "-" + level + "&op=" + op + "#" + id + "\" onmouseover=\"status='" +
                   prettyOp + " node'; return true;\" onmouseout=\"status=''\"><img src=\"" + imagesDir +
                   op + type + ".gif\" alt=\"" + prettyOp + " node\" border=\"0\" /></a>");
    } else {
        gOut.print("<img src=\""+imagesDir+"tree" + type + ".gif\" border=\"0\" /></a>");
    }
    // print node
    if (showLink) {
        gOut.print("<a title=\"View Class\" class=\"tree\" ");
        if (isAbstract) {
            gOut.print("id=\"abstract\" ");
        }
        cat.info(" Before cleaning Id = "+ id);
        String cleanedId=cleanId(id);
        cat.info(" After cleaning Id =" + cleanedId);
        cat.info("tree.jsp .. kbName = " + kbName);
        gOut.print("href=\"javascript:synchronize('"+kbName+"','"+id +"');\"" + " onmouseover=\"status='View " +
       name + "'; return true;\" onmouseout=\"status=''\">");

    }
    gOut.print("<img src=\"" + imagesDir);
    if (isLeaf) {
        gOut.print("instance-red.gif\" alt=\"Instance\"");
    } else {
        if (isMeta) {
            gOut.print("class-green.gif\" alt=\"Metaclass\"");
        } else {
            gOut.print("class-yellow.gif\" alt=\"Class\"");
        }
    }
    gOut.print(" border=\"0\">");
boolean blink=false;
String highlightId=(String)gRequest.getParameter("id");
String operation=gRequest.getParameter("op");
if(operation==null){
operation="";
}
if(highlightId!=null && (operation.equalsIgnoreCase("open") || operation.equalsIgnoreCase("close"))){
highlightId=highlightId.substring(0,highlightId.length()-2);
}
if(id.equals(highlightId)){
gOut.print("<span id=\"classId_"+id+"\" style=\"background-color:green;color:yellow\">" +name + "</span>");
gOut.print("<script langauge=javascript>previousInstanceId='"+id+"';</script>");
}else{
gOut.print("<span id=\"classId_"+id+"\">" +name + "</span>");
}

gOut.print("</img>");
    if (showLink) {
        gOut.print("</a>");
    }

gOut.print(abstractImageHtml);
gOut.print(multipleParentsImageHtml);
    gOut.print("<b title=\"(Num SubClasses, Num Instances)\" onmouseover=\"status='Number of subclasses,Number of Instances'; return true;\" onmouseout=\"status=''; return true;\" alt='(Number of subclasses,Number of Instances)'>(" + numChildren + "," + numInstances+")</b>");

    // add link if this is the current node of interest
    if (currentNodeIsLevelId) {
        if (levelId.equals(currentNode)) {
            gOut.print("<a name=\"" + id + "\" />");
        }
    } else {
        if (id.equals(currentNode)) {
            gOut.print("<a name=\"" + id + "\" />");
        }
    }
    gOut.println("");
    // print subtree if necessary
    if (numChildren > 0 && isOpen.booleanValue()) {
        if (index != (parentChildCount - 1)) {
            grandparentIsAlone = false;
        } else {
            grandparentIsAlone = true;
        }
        for (int x = 0; x < numChildren; x++) {
            printSubtree((Frame)treeModel.getChild(id, x), (level + 1), x, numChildren,
                         grandparentIsAlone, new StringBuffer(treeLayout.toString()), showLeaf, showLink);
        }
    }
}


void printTree(HttpServletRequest request, JspWriter out) throws java.io.IOException {

    // make this available globally so functions can access them
gOut = out;
    gRequest = request;
     treeParams = new StringBuffer();

    // get TreeModel
    String rootId = gRequest.getParameter("rootId");
    boolean showLeaf = false;
KnowledgeBase knowledgeBase=null;
try{
cat.info("IN printTree .. kbName = " + kbName);
knowledgeBase=KBManager.openKB(kbName);
}catch (Exception ex){
	ex.printStackTrace();
}

    if (rootId == null) {
        treeModel = KBTreeModelManager.getTreeModel(knowledgeBase, showLeaf);
        rootId = "***ROOT***";
    } else {
        treeModel = KBTreeModelManager.getTreeModel(knowledgeBase, rootId, showLeaf);
        treeParams.append("&rootId=" + rootId);
    }
    if (treeModel == null) {
        gOut.println("<h3 id=\"error\">KB Not Found!</h3>" +
                     "<p id=\"error\">The KB named \"" + kbName + "\" cannot be found.</p>");
        return;
    }
    // get rootNode and make sure treeModel is ok
    Object rootNode = treeModel.getRoot();

    // retrieve view info from session
    String nodeStatusMapId = "NodeSatusMapId for " + kbName + " - " + rootId;
    nodeStatusMap = (HashMap)gRequest.getSession().getAttribute(nodeStatusMapId);
    if (nodeStatusMap == null) {
        nodeStatusMap = new HashMap();
        gRequest.getSession().setAttribute(nodeStatusMapId, nodeStatusMap);
    }
    // check for node status change
    String op = gRequest.getParameter("op");
    if (op != null) {
        currentNode = gRequest.getParameter("id");
        if (currentNode != null) {
            if (op.equals("find")) {
                // get the tree path for this node
                TreePath path = treeModel.getTreePathTo(currentNode);
                for (int x = 0; x < (path.getPathCount() - 1); x++) {
                    String id = (String)path.getPathComponent(x);
                    nodeStatusMap.put((id + "-" + x), new Boolean(true));
                }
                currentNodeIsLevelId = false;
            } else {
                if (op.equals("open")) {
                    nodeStatusMap.put(currentNode, new Boolean(true));
                } else if (op.equals("close")) {
                    nodeStatusMap.put(currentNode, new Boolean(false));
                }
                currentNodeIsLevelId = true;
            }
        }
    }

    // check for other parameters
    boolean showLink = true;
    if (request.getParameter("nolink") != null) {
        showLink = false;
        treeParams.append("&nolink=1");
    }

    // set things up for printSubtree
    // print tree
    gOut.println("<pre>");
    int numChildren = treeModel.getChildCount(rootNode);
    for (int x = 0; x < numChildren; x++) {
        printSubtree((Frame)treeModel.getChild(rootNode, x), 0, x, numChildren, ((numChildren == 1) ? true : false), new StringBuffer(), showLeaf, showLink);
    }
    gOut.println("</pre>");
}
%>
