  <%
  /*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s): Kamran Ahsan
 */
  %>
  <%@  page  errorPage="errorPage.jsp" contentType="text/html" import="java.net.*, java.util.*, java.io.File,webprotege.*,edu.stanford.smi.protege.model.*,webprotege.query.*,webprotege.exception.*,webprotege.util.comparators.*,webprotege.util.*,org.apache.log4j.*" %>
<%! protected Category cat;%>
  <%!
  private String getImageHtmlForFrame(Frame frame){
  if (frame==null){
          return "";
  }
  String imageHtml="";
  if (frame instanceof Instance && !(frame instanceof Cls) && !(frame instanceof Slot) ){
          imageHtml="<img src=images" + File.separator + "Instance.gif border=0/>";
  }else if (frame instanceof Cls){
  if( ((Cls)frame).isMetaCls()){
          imageHtml="<img src=images" + File.separator + "Metaclass.gif border=0/>";
  }else{
          imageHtml="<img src=images" + File.separator + "Class.gif border=0/>";
  }
  }else if(frame instanceof Slot){
          imageHtml="<img src=images" + File.separator + "Slot.gif border=0/>";
  }else{
  //    imageHtml=frame.getBrowserText();
  }
  return imageHtml;
  }
  %>
  <head>
  <title>
  Instances
  </title>
  <link rel="stylesheet" type="text/css" href="style/kb.css" />
<SCRIPT LANGUAGE="JavaScript">
// Generic function converts form element name-value pairs
// into a URL search string.
function getFormData(form) {
	var searchString = "?"
	var onePair
	// Harvest values for each type of form element
	for (var i = 0; i < form.elements.length; i++) {
		if (form.elements[i].type == "text") {
			onePair = escape(form.elements[i].name) + "="
			onePair += escape(form.elements[i].value)
		} else if (form.elements[i].type == "hidden") {
			onePair = escape(form.elements[i].name) + "="
			onePair += escape(form.elements[i].value)
		} else if (form.elements[i].type.indexOf("select") != -1) {
			onePair = escape(form.elements[i].name) + "="
			onePair += escape(form.elements[i].options[form.elements[i].selectedIndex].value)
		} else if (form.elements[i].type == "radio") {
			onePair = escape(form.elements[i].name) + "="
			onePair += escape(form.elements[i].value)
		} else if (form.elements[i].type == "checkbox") {
			onePair = escape(form.elements[i].name) + "="
			onePair += escape(form.elements[i].value)
		} else continue
		searchString += onePair + "&"
	}
	return searchString
}

// Send gathered data to the dialog window object's returnedValue property
function transferData() {
  if (top.opener && !top.opener.closed) {
		top.opener.dialogWin.returnedValue = unescape(getFormData(document.selectFrameForm))
	}
}

function handleFrameClick(frameId,frameLabel){
  document.selectFrameForm.frame_id.value=frameId;
  document.selectFrameForm.frame_label.value=frameLabel;
  top.handleInstanceClick();
  }

</SCRIPT>

<%
  cat=Category.getInstance("selectInstances.jsp");
  String frameId=request.getParameter("id");
  String kbName=request.getParameter("kb");
  cat.debug("kbName "  + kbName);
  int instanceCount=0;

  if(kbName!=null){
   kbName=URLDecoder.decode(kbName,"UTF-8");
   KnowledgeBase kb;
      try {
          kb = KBManager.openKB(kbName);
      } catch (Exception ex) {
        cat.error("Error in display Instances while opening KB: kbName = " + kbName);
        throw new Exception("Internal Exception");
      }
  cat.debug("Getting " + frameId + " from " + kb);
  Frame frame = (Frame)kb.getFrame(frameId);
%>
  </head>
<FORM NAME="selectFrameForm">
<input type="hidden" id="frame_id" name="frame_id" value=""/>
<input type="hidden" id="frame_label" name="frame_label" value=""/>
</form>
  </p>
  <p>
  <%
  if(frame instanceof Cls){
  Collection instances = kb.getDirectInstances((Cls)frame);
  Object[] array=instances.toArray();
  Arrays.sort(array,new FrameComparator());
  %>

  <table width="98%" border="0" cellpadding="2" cellspacing="0">
  <tr>
  <td align="center"><!--<img title="Direct Instances for <%=frame.getBrowserText()%>" src="images<%=File.separator%>Instances.gif" border="0" />--><font color="#ffffff" title="Direct Instances for the Chosen Class" class="highlight"><b>Direct Instances</b></font>
  </td>
  </tr>
  <%
  for(int counter=0;counter<array.length;counter++){
  String bgColor="";
  String imageHtml="";
  if(counter%2==0){
  bgColor="#cccccc";
  }
  Instance i = (Instance)array[counter];
  cat.debug("instance   = " + i );
  Cls directType=kb.getDirectType(i);
  cat.debug("directType = " + directType);

  instanceCount++;
  String highlightHtmlStart="";
  String highlightHtmlEnd="";
  String encodedInstanceName=java.net.URLEncoder.encode(i.getName(),"UTF-8");
  String instanceBrowserText="";
  if(directType.getBrowserSlot()==null || i.getBrowserText().toLowerCase().indexOf("not set")>0){
    instanceBrowserText=i.getName();
    }else{
      instanceBrowserText=i.getBrowserText();
      }
  String encodedInstanceLabel=java.net.URLEncoder.encode(instanceBrowserText,"UTF-8");

  %>

  <tr bgcolor="<%=bgColor%>">
  <td><%=getImageHtmlForFrame(i)%>
  <a href="javascript:handleFrameClick('<%=encodedInstanceName%>',escape('<%=instanceBrowserText%>'))">
  <span id="fontStyle_<%=instanceCount%>" name="fontStyle_<%=encodedInstanceName%>" rowIndex="<%=instanceCount%>"><%=highlightHtmlStart + instanceBrowserText+ highlightHtmlEnd%></span>
  </a>
  </td>
  </tr>
  <%
  }
  out.println("</table>");
  }else{
  }

  }else{
  out.println("KB Not Found");
  }
  %>
